diff --git a/init.c b/init.c
index 079e270141..dd304537c5 100644
--- a/init.c
+++ b/init.c
@@ -1880,8 +1880,8 @@ static int parse_my_hdr(struct Buffer *buf, struct Buffer *s,
     FREE(&n->data);
   }
 
-  n->data = buf->data;
-  mutt_buffer_init(buf);
+  n->data = mutt_str_strdup(buf->data);
+  mutt_buffer_reinit(buf);
 
   return 0;
 }
